--TEST--
Basic features using FileSystem cache engine
--FILE--
<?php
namespace cs;
include __DIR__.'/../custom_loader.php';
Core::instance_stub(
	[
		'cache_engine' => 'FileSystem'
	]
);
$Cache = Cache::instance();
if (!$Cache->cache_state()) {
	die('Cache state check failed');
}
$value = uniqid('cache', true);
if (!$Cache->set('test', $value)) {
	die('::set() failed');
}
if ($Cache->test !== $value) {
	die('::get() failed');
}
if (!$Cache->del('test')) {
	die('::del() failed');
}
if ($Cache->get('test') !== false) {
	die('Value still exists');
}
if (!$Cache->set('test', 5)) {
	die('::set() failed (2)');
}
$Cache->disable();
if ($Cache->cache_state() !== false) {
	die('::cache_state() method does not work');
}
if ($Cache->test !== false) {
	die('Value still exists');
}
if ($Cache->get('xuz', function () {return 5;}) !== 5) {
	die('Callback is not called for disabled cache');
}
?>
Done
--EXPECT--
Done
--CLEAN--
<?php
include __DIR__.'/../custom_loader.php';
exec('rm -r '.CACHE.'/*');
?>
